#include "harlander.hh"


struct s_complex { double re; double im; };
extern "C" {
  s_complex harlander_(s_complex *x, s_complex *t);
}
dcomplex harlander_G2l(double mh_2mt_ratio) {
  dcomplex t = pow(mh_2mt_ratio,2) + I*1.e-15;
  dcomplex x = (sqrt(1-1./t)-1)/(sqrt(1-1./t)+1);
  dcomplex F0H = 3./2./t/t*(t+(t-1)*pow(asin(sqrt(real(t))),2));
  if(real(t)>1) F0H = 3./2./t/t*(t-(t-1)/4.*pow(log((1+sqrt(1-1./t))/(1-sqrt(1-1./t)))-I*M_PI,2));
  s_complex res, xx={real(x),imag(x)}, tt={real(t),imag(t)};
  res= harlander_(&xx, &tt);
  return real(res/F0H);
}

